<script setup>
import { useWorkspaceStore } from "@/stores/useWorkspaceStore";
////////////////////////////////
// IMPORT
////////////////////////////////
import { ref } from "vue";

////////////////////////////////
// Emits
////////////////////////////////
const emits = defineEmits(["showDialog"]);

////////////////////////////////
// DATA
////////////////////////////////
const workspaceStore = useWorkspaceStore();

const workspaceMembers = ref(workspaceStore.workspaceMemberMap);
const workspaceName = workspaceStore.currentWorkspace?.name;
const editedName = ref(workspaceStore.currentWorkspace?.name);
const isEditingName = ref(false);
const workspaceNameInput = ref("");
const leaveModal = ref(false);
const deleteModal = ref(false);

////////////////////////////////
// LIFECYCLE
////////////////////////////////
onMounted(async () => {
  await workspaceStore.fetchWorkspaceMembers();
});

////////////////////////////////
// FUNCTIONS
////////////////////////////////

function enableEditing() {
  isEditingName.value = true;
}

async function saveName() {
  const editedWorkspace = await workspaceStore.updateWorkspace(
    workspaceStore.currentWSlug,
    editedName.value,
    workspaceStore.currentWorkspace?.description,
  );
  workspaceStore.currentWorkspace.name = editedName.value;
  workspaceStore.currentWSlug = editedWorkspace.slug;
  isEditingName.value = false;
  await navigateTo(`/${workspaceStore.currentWSlug}`);
}

function cancelEdit() {
  editedName.value = workspaceStore.currentWorkspace?.name;
  isEditingName.value = false;
}

function openDeleteModal() {
  deleteModal.value = true;
}

function closeDeleteModal() {
  deleteModal.value = false;
}

function openLeaveModal() {
  leaveModal.value = true;
}

function closeLeaveModal() {
  leaveModal.value = false;
}

async function leaveWorkspace() {
  // Handle leaving workspace
  workspaceStore
    .deleteWorkspaceMember(workspaceStore.currentWorkspaceMember.value)
    .then(async (res) => {
      if (res === true) {
        await workspaceStore.fetchWorkspaces();
        await navigateTo("/");
        closeLeaveModal();
        emits("showDialog", false);
      }
    });
}

async function deleteWorkspace() {
  // Handle deleting workspace
  await workspaceStore.deleteWorkspace(workspaceStore.currentWSlug);
  // Redirect to "/"
  await navigateTo("/");
  closeDeleteModal();
  emits("showDialog", false);
}

function canLeaveCurrentWorkspace() {
  if (workspaceMembers.value) {
    if (workspaceMembers.value.size > 1) {
      let countOwners = 0;
      workspaceMembers.value.forEach((member) => {
        if (member.value.role.role === "owner") {
          countOwners++;
        }
      });

      if (countOwners === 1) {
        return false;
      } else {
        return true;
      }
    }
  }
  return false;
}

function canEditOrDeleteCurrentWorkspace() {
  const role = workspaceStore.currentWorkspaceMember?.value.role.role;
  return role === "owner";
}
</script>

<template>
  <div class="pa-4">
    <v-sheet class="me-auto" style="overflow: hidden; white-space: nowrap; text-overflow: ellipsis">
      <h1>{{ $t("workspace_settings") }}</h1>
    </v-sheet>
    <hr class="mb-3">
    <!-- Section "Name" -->
    <div class="mt-4">
      <h2 class="mb-3 me-auto">
        Name
      </h2>
      <v-container>
        <v-row align="center">
          <v-col cols="auto">
            <v-text-field
              v-model="editedName"
              :readonly="!canEditOrDeleteCurrentWorkspace()"
              class="text-field"
              @input="enableEditing"
            />
          </v-col>
          <v-col
            v-if="isEditingName"
            class="mb-5"
            cols="auto"
          >
            <v-icon class="check-icon cursor-pointer" @click="saveName">
              mdi-check
            </v-icon>
            <v-icon class="cancel-icon cursor-pointer" @click="cancelEdit">
              mdi-close
            </v-icon>
          </v-col>
        </v-row>
      </v-container>
    </div>
    <!-- Section "Danger" -->
    <div class="mt-4">
      <h2 class="mb-3 me-auto text-error">
        Danger zone
      </h2>
      <div>
        <v-tooltip location="bottom" :disabled="canLeaveCurrentWorkspace()">
          <template v-slot:activator="{ props }">
            <div v-bind="props" class="d-inline-block">
              <v-btn
                :disabled="!canLeaveCurrentWorkspace()"
                style="margin-left: 20px"
                @click="openLeaveModal"
              >
                Leave Workspace
              </v-btn>
            </div>
          </template>
          <span>You can't leave this workspace as you are the only owner</span>
        </v-tooltip>
        <v-tooltip location="bottom" :disabled="canEditOrDeleteCurrentWorkspace()">
          <template v-slot:activator="{ props }">
            <div v-bind="props" class="d-inline-block">
              <v-btn
                color="error"
                :disabled="!canEditOrDeleteCurrentWorkspace()"
                style="margin-left: 20px"
                @click="openDeleteModal"
              >
                Delete Workspace
              </v-btn>
            </div>
          </template>
          <span>You need to be owner to delete this Workspace</span>
        </v-tooltip>
      </div>
    </div>

    <!-- Delete Workspace Modal -->
    <v-dialog v-model="deleteModal" max-width="500">
      <v-card>
        <v-card-title>Do you really want to delete this workspace?</v-card-title>
        <v-card-text>
          <p>
            By deleting this workspace all the associated nodes, as well as the datalinks will be
            deleted.
          </p>

          <div v-if="workspaceName">
            <p class="mt-2">
              To confirm, type the name of the workspace:
            </p>

            <v-text-field
              v-if="workspaceNameInput !== workspaceName"
              v-model="workspaceNameInput"
              label="workspace name"
              autofocus
              variant="solo"
            />
            <v-text-field
              v-else
              v-model="workspaceNameInput"
              label="workspace name"
              variant="solo"
              autofocus
              @keyup.enter="deleteWorkspace()"
            />
          </div>
        </v-card-text>
        <v-card-actions>
          <v-btn @click="closeDeleteModal">
            Cancel
          </v-btn>
          <v-btn
            color="error"
            :disabled="workspaceNameInput !== workspaceName"
            @click="deleteWorkspace()"
          >
            Delete the workspace
          </v-btn>
        </v-card-actions>
      </v-card>
    </v-dialog>

    <!-- Leave Workspace Modal -->
    <v-dialog
      v-model="leaveModal"
      width="auto"
      persistent
    >
      <v-card>
        <v-card-title><v-icon>mdi-exit-to-app</v-icon> Leaving the workspace</v-card-title>
        <v-card-text>
          You are about to leave the workspace <b>{{ workspaceName }}</b>. <br>
          Are you sure?
        </v-card-text>
        <v-card-actions class="d-flex flex-row-reverse">
          <v-btn color="error" @click="leaveWorkspace()">
            Leave
          </v-btn>
          <v-btn @click="closeLeaveModal()">
            Cancel
          </v-btn>
        </v-card-actions>
      </v-card>
    </v-dialog>
  </div>
</template>

<style>
.text-field {
  width: 100%;
  min-width: 400px;
  max-width: 800px;
}
</style>
